#include <stdio.h>
#include <malloc.h>

struct _oke{
	unsigned int	size;	//+00
	unsigned int	data;	//+04
	unsigned int	and;	//+08
	unsigned int	dif;	//+0C
	unsigned int	shft;	//+10
	unsigned char	*ptr;	//+14
} oke;

//00200BC0
void _unpack_raw_1(){
	oke.data =             *oke.ptr++  << 8;
	oke.data = (oke.data | *oke.ptr++) << 8;
	oke.data = (oke.data | *oke.ptr++) << 8;
	oke.data =  oke.data | *oke.ptr++;
	oke.shft=0x3FFF >> (oke.data & 3);
	oke.dif=14 - (oke.data & 3);
	oke.and=oke.data & 3;
}

//00200C48
void _unpack_raw(unsigned char *base){
	unsigned int val, count, i;
	unsigned char *p, *src;

	for (i=0, p=base; p < base+oke.size; i--, oke.data <<= 1){
		if (i == 0){	i=30;	_unpack_raw_1();	}
		if (oke.data & 0x80000000){
			val  = *oke.ptr++ << 8;
			val |= *oke.ptr++;
			src = p - (val & oke.shft) - 1;
			count = (val >> oke.dif) + 2;
			do *p++ = *src++; while (count--);
		}else
			*p++ = *oke.ptr++;
		printf("Unpacking %3d%%\r", (p-base)*100/oke.size);
	}
}

int main(int argc, char* argv[]){
	FILE *f;
	unsigned char *src, *dest;
	unsigned int size;

	if (argc<3){
		printf("Usage: unpack.exe <file_raw> <destination>\n");
		return 1;
	}
	f=fopen(argv[1], "rb");
	if (!f){
		printf("Could not open %s\n", argv[1]);
		return 2;
	}
	fseek(f, 0, SEEK_END);
	size=ftell(f);
	fseek(f, 0, SEEK_SET);
	src=(char*)malloc(size);
	fread(src, size, 1, f);
	fclose(f);

	oke.size=*(unsigned int*)src;
	oke.ptr =src+4;

	dest=(char*)malloc(oke.size);
	_unpack_raw(dest);

	f=fopen(argv[2], "wb");
	if (f){
		fwrite(dest, oke.size, 1, f);
		fclose(f);
	}else
		printf("Could not write to %s\n", argv[2]);

	free(dest);
	free(src);
	return 0;
}
